// scripts for IARrific - nicktech.org

function PARCCvalAll() {
    $j('.parccVal').each(function () {
        validateElement($j(this));
    });
    return "";
}
function tableStripe() {
    $j('#myform table tr:visible:even td').css("background-color", "white");
    $j('#myform table tr:visible:odd td').css("background-color", "#eee");
}

// *** start PS validation

var iep_504 = "";
if ($j('.il_iep:contains("Yes")').length > 0 || $j('.il_504:contains("Yes")').length > 0) {
    iep_504 = "yes"
} else {
    iep_504 = "no"
}

// New PS validation
// ela
function ela_iep_paper_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && ($j('#PARCC_ELA_Test_Format').val() !== 'P' || iep_504 === "no")) {
        return "Requires ELA Test Format be paper<br>and IEP or 504";
    }
}
function ela_paper_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && ($j('#PARCC_ELA_Test_Format').val() !== 'P')) {
        return "Requires ELA Test Format be paper";
    }
}
function ela_iep_online_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && ($j('#PARCC_ELA_Test_Format').val() == 'P' || iep_504 === "no")) {
        return "Requires ELA Test Format be online<br>and IEP or 504";
    }
}
function ela_el_iep_online_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && ($j('#PARCC_ELA_Test_Format').val() == 'P' || (iep_504 === "no" && $j('.il_lep:contains("No")').length > 0))) {
        return "Requires ELA Test Format be online<br>and IEP or 504 or LEP";
    }
}
function ela_iep_online_select(jQueryInput) {
    if ($j(jQueryInput).val() && ($j('#PARCC_ELA_Test_Format').val() == 'P' || iep_504 === "no")) {
        return "Requires ELA Test Format be online<br>and IEP or 504";
    }
}
function ela_online_select(jQueryInput) {
    if ($j(jQueryInput).val() && ($j('#PARCC_ELA_Test_Format').val() == 'P')) {
        return "Requires ELA Test Format be online";
    }
}
// math
function math_iep_paper_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && ($j('#PARCC_Math_Test_Format').val() !== 'P' || iep_504 === "no")) {
        return "Requires Math Test Format be paper<br>and IEP or 504";
    }
}
function math_paper_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && ($j('#PARCC_Math_Test_Format').val() !== 'P')) {
        return "Requires Math Test Format be paper";
    }
}
function math_iep_online_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && ($j('#PARCC_Math_Test_Format').val() == 'P' || iep_504 === "no")) {
        return "Requires Math Test Format be online<br>and IEP or 504";
    }
}
function math_online_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && ($j('#PARCC_Math_Test_Format').val() == 'P')) {
        return "Requires Math Test Format be online";
    }
}
function math_el_iep_online_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && ($j('#PARCC_Math_Test_Format').val() == 'P' || (iep_504 === "no" && $j('.il_lep:contains("No")').length > 0))) {
        return "Requires Math Test Format be online<br>and IEP or 504 or LEP";
    }
}
function math_iep_online_select(jQueryInput) {
    if ($j(jQueryInput).val() && ($j('#PARCC_Math_Test_Format').val() == 'P' || iep_504 === "no")) {
        return "Requires Math Test Format be online<br>and IEP or 504";
    }
}
function math_online_select(jQueryInput) {
    if ($j(jQueryInput).val() && ($j('#PARCC_Math_Test_Format').val() == 'P')) {
        return "Requires Math Test Format be online";
    }
}
function calculator(jQueryInput) {
    var stugrade = String($j('.stugrade').text().trim());
    if ($j(jQueryInput).val() === '01' && ($j('#PARCC_Math_Test_Format').val() !== 'P' || iep_504 === "no")) {
        return "Calculation Device and Mathematics Tool<br>Requires Math Test Format be paper<br>and IEP or 504";
    }
    if ($j(jQueryInput).val() === '02' && ($j('#PARCC_Math_Test_Format').val() == 'P')) {
        return "Handheld Calculator<br>Requires Math Test Format be online";
    }
    if ($j(jQueryInput).val() === '05' && ($j('#PARCC_Math_Test_Format').val() == 'P' || iep_504 === "no" || stugrade == '8')) {
        return "Online Calculator - Four Function<br>Requires Math Test Format be online<br>Grades 3-7<br>and IEP or 504";
    }
    if ($j(jQueryInput).val() === '06' && ($j('#PARCC_Math_Test_Format').val() == 'P' || iep_504 === "no" || stugrade != '8')) {
        return "Online Calculator - TI-30 Scientific<br>Requires Math Test Format be online<br>Grade 8<br>and IEP or 504";
    }
}

// science
function science_iep_paper_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && (!$j('#IAR_Sci_Paper_Trans_yes').is(':checked') || iep_504 === "no")) {
        return "Requires Science Test Format be paper<br>and IEP or 504";
    }
}
function science_paper_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && (!$j('#IAR_Sci_Paper_Trans_yes').is(':checked'))) {
        return "Requires Science Test Format be paper";
    }
}
function science_iep_online_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && $j(iep_504 === "no")) {
        return "Requires IEP or 504";
    }
}
function science_el_iep_online_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && (iep_504 === "no" && $j('.il_lep:contains("No")').length > 0)) {
        return "Requires IEP or 504 or LEP";
    }
}
function science_iep_online_select(jQueryInput) {
    if ($j(jQueryInput).val() && iep_504 === "no") {
        return "Requires IEP or 504";
    }
}

// all
function el_both_select(jQueryInput) {
    if ($j(jQueryInput).val() && ($j('.il_lep:contains("No")').length > 0)) {
        return "Requires LEP";
    }
}
function el_iep_both_select(jQueryInput) {
    if ($j(jQueryInput).val() && ($j('.il_lep:contains("No")').length > 0 && iep_504 === "no")) {
        return "Requires LEP or IEP or 504";
    }
}
function iep_both_radio(jQueryInput) {
    if ($j(jQueryInput).is(':checked') && (iep_504 === "no")) {
        return "Requires IEP or 504";
    }
}
// end new validation

// runs at page submit to clear fields if their containing div is hidden
function clear_hidden() {
    if (!$j("#ela_accommodations").is(':checked')) {
        $j("#ela_div").children().find("input,select").each(function () {
            $j(this).val('');
        });
    }
    if (!$j("#math_accommodations").is(':checked')) {
        $j("#math_div").children().find("input,select").each(function () {
            $j(this).val('');
        });
    }
    if (!$j("#science_accommodations").is(':checked')) {
        $j("#science_div").children().find("input,select").each(function () {
            $j(this).val('');
        });
    }
}
$j('#myform').submit(clear_hidden);

// runs at page load
$j(function () {
    // determine if values exist from other state page and if so check parent box and alert
    var elaradio = 0;
    var eladropdown = 0;
    var elatotal = 0;
    var mathradio = 0;
    var mathdropdown = 0;
    var mathtotal = 0;
    var scienceradio = 0;
    var sciencedropdown = 0;
    var sciencetotal = 0;

    $j("#ela_div input.radioYes:checked").each(function () {
        elaradio += Number($j(this).val());
    })
    $j("#ela_div select").each(function () {
        eladropdown += Number($j(this).val());
    })
    var elatotal = elaradio + eladropdown;
    if (elatotal > 0 && (!$j('#ela_accommodations').is(':checked'))) {
        $j('#ela_accommodations').prop('checked', true);
        $j('#ela_div_message').show();
    }
    $j("#math_div input.radioYes:checked").each(function () {
        mathradio += Number($j(this).val());
    })
    $j("#math_div select").each(function () {
        mathdropdown += Number($j(this).val());
    })
    var mathtotal = mathradio + mathdropdown;
    if (mathtotal > 0 && (!$j('#math_accommodations').is(':checked'))) {
        $j('#math_accommodations').prop('checked', true);
        $j('#math_div_message').show();
    }
    $j("#science_div input.radioYes:checked").each(function () {
        scienceradio += Number($j(this).val());
    })
    $j("#science_div select").each(function () {
        sciencedropdown += Number($j(this).val());
    })
    var sciencetotal = scienceradio + sciencedropdown;
    if (sciencetotal > 0 && (!$j('#science_accommodations').is(':checked'))) {
        $j('#science_accommodations').prop('checked', true);
        $j('#science_div_message').show();
    }

    // when ela/math/science is checked unchecked
    $j("#ela_accommodations").on('change', function () {
        if ($j(this).is(':checked')) {
            $j('#ela_div').show();
        }
        else if ($j(this).prop('checked') === false && $j('#ela_div .error-message').is(":visible")) {
            $j('#ela_accommodations').prop('checked', true);
            alert('Please correct errors in ELA accommodations before unchecking the accommodations checkbox and submitting');
        }
        else {
            $j('#ela_div').hide();
        }
    });
    $j("#math_accommodations").on('change', function () {
        if ($j(this).is(':checked')) {
            $j('#math_div').show();
        }
        else if ($j(this).prop('checked') === false && $j('#math_div .error-message').is(":visible")) {
            $j('#math_accommodations').prop('checked', true);
            alert('Please correct errors in math accommodations before unchecking the accommodations checkbox and submitting');
        }
        else {
            $j('#math_div').hide();
        }
    });
    $j("#science_accommodations").on('change', function () {
        if ($j(this).is(':checked')) {
            $j('#science_div').show();
        }
        else if ($j(this).prop('checked') === false && $j('#science_div .error-message').is(":visible")) {
            $j('#science_accommodations').prop('checked', true);
            alert('Please correct errors in science accommodations before unchecking the accommodations checkbox and submitting');
        }
        else {
            $j('#science_div').hide();
        }
    });
    $j("#ela_accommodations, #math_accommodations, #science_accommodations").trigger('change');
    setTimeout(function () {
        $j("#PARCC_ELA_DirRead_StuNtLng, #PARCC_Math_DirRead_StuNtLng, #IAR_Sci_StuNative_Lang").trigger('change');
    }, 1000);
    // highlight obsolete values
    $j("option:selected:contains('obsolete')").closest("select").after('<div class="alertError">This is an obsolete value and should be changed</div>');

    //IAR validation update on change 
    $j('#PARCC_ELA_Test_Format, #PARCC_Math_Test_Format, #IAR_Sci_Paper_Trans_yes, #IAR_Sci_Paper_Trans_no, #ela_div input, #math_div input, #science_div input, #ela_div select, #math_div select, #science_div select').on('change', PARCCvalAll);

}); // end on ready